/*-------------------------------------------------------------------------
	Copyright (C) 2008-2009 American Megatrends Inc.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		     
-------------------------------------------------------------------------*/
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/delay.h>
#include <linux/slab.h>
#include <linux/init.h>
#include <linux/interrupt.h>
#include <linux/wait.h>
#include <asm/io.h>
#include <asm/irq.h>
#include "i2c-data.h"
#include "i2c-hardware.h"


struct i2c_vsc_data vsc_data_ptr[BUS_COUNT];


i2c_bus_status_t i2c_bus_status_ptr[BUS_COUNT];
sharedbus_stats_t g_sharedbus_stats[SEGMENT_COUNT];
unsigned char  g_mux_chan[BUS_COUNT];


void i2c_init_internal_data(int bus)
{

	/* Initialize locks, queues and variables */
	spin_lock_init (&vsc_data_ptr[bus].data_lock);
	init_waitqueue_head (&(vsc_data_ptr[bus].vsc_wait)); 

	vsc_data_ptr[bus].TX_len = 0;
	vsc_data_ptr[bus].TX_index = 0;

	vsc_data_ptr[bus].MasterRX_len = 0;
	vsc_data_ptr[bus].MasterRX_index = 0;


	vsc_data_ptr[bus].state = STATE_IDLE;

	return;
}



void i2c_init_status_data(int bus)
{
	int i;
	
	i2c_bus_status_ptr[bus].TX_index = 0;

	i2c_bus_status_ptr[bus].MasterRX_index = 0;


	g_mux_chan[bus] = 0;
	i2c_bus_status_ptr[bus].dev_index_cnt = 0;
	i2c_bus_status_ptr[bus].duplicate_set_cnt = 0;
	
	if (bus == I2C_BUS_2) {
		for (i=0;i<SEGMENT_COUNT;i++) {
			g_sharedbus_stats[i].l_rel_short_timeout = 0;
			g_sharedbus_stats[i].l_rel_long_timeout = 0;
			g_sharedbus_stats[i].l_rm_grant_timeout = 0;
			g_sharedbus_stats[i].l_rm_rel_timeout = 0;
			g_sharedbus_stats[i].l_serial_exchange_error = 0;
			g_sharedbus_stats[i].r_rel_short_timeout = 0;
			g_sharedbus_stats[i].r_rel_long_timeout = 0;
			g_sharedbus_stats[i].r_loc_grant_timeout = 0;
			g_sharedbus_stats[i].r_loc_rel_timeout = 0;
			g_sharedbus_stats[i].r_serial_exchange_error = 0;
			

		}
	}

	for (i=0; i<MAX_COMB_ADDR; i++) {
		i2c_bus_status_ptr[bus].hash_table[i].collision_cnt = HASH_INDEX_VACANT;
		i2c_bus_status_ptr[bus].hash_table[i].dev_stat_index_base = 0x0;

	}

	for (i=0;i<MAX_NUM_7BIT_SLAVE_ADDR;i++) {
		i2c_bus_status_ptr[bus].dev_stat[i].counter = 0;
		i2c_bus_status_ptr[bus].dev_stat[i].present = 0;
		i2c_bus_status_ptr[bus].dev_stat[i].mode = STATE_IDLE;
		i2c_bus_status_ptr[bus].dev_stat[i].xmit_cnt = 0;
		i2c_bus_status_ptr[bus].dev_stat[i].recv_cnt = 0;
		i2c_bus_status_ptr[bus].dev_stat[i].recovery_cnt = 0;
		i2c_bus_status_ptr[bus].dev_stat[i].busy_cnt = 0;
		i2c_bus_status_ptr[bus].dev_stat[i].failure_cnt = 0;
	}

}



